/**************************************************************
	12F629/12F675
	Electric sand timer
	dqv ͂Ԃr[Ro[W
	author air_variable
	1.00 2010/11/23 The first release
	Tools:
	MPLAB 8.56
	Hitech PICC Pro Lite mode v9.80

	Pin assignment:
	(1)Vdd					[PICKIT2-2] 
	(2)GPIO5	LED RED(neg)
	(3)NC
	(4)reset				[PICKIT2-1]	(Vpp) Vdd bitween resister 10Kohm
	(5)GPIO4	Piezo(neg)
	(6)GPIO1				[PICKIT2-5]
	(7)GPIO0				[PICKIT2-4]
	(8)Vss					[PICKIT2-3]

	
	PDdr܂BႢr[vҋ@ԂłB
	QDsG]fqɌyՌ^ƁALED_܂B
	̍ŒɂxՌ^ƁAr[vn߁AvJn܂B
	RDPb݂ŃNbNA1ɏłȂ܂B
	SDK莞ԁĩvOł͂RjoƁAԌo߂\A
	LED2b_Aҋ@Ԃɖ߂܂B
	
	̑
	^C}[͎̒ɊÂčsĂ܂B

**************************************************************/

#include <htc.h>
#define MHz 000000
#define _XTAL_FREQ 4MHz

#define LED_RED		GPIO5	//active low
#define PIEZO		GPIO2	//active low
#define SET_TIMER	3		//timer 3 minute
#define RESULT_BEEP	4		//result of beep times 10 times

__CONFIG(0x3FA4);	//InternalClockNoCLKOUT,WatchdogOff,PowerUpTimerOn,MasterClearEnableInternal,
					//BrownOutOff//CodeProtectOff,EEProtectOff

//Delay 100msec --------------------------------
void Delay_100ms(unsigned char time){
	while(time--){
		__delay_ms(30);//total 100ms
		__delay_ms(30);
		__delay_ms(30);
		__delay_us(10000);//
	}
}

//Beep sound 4KHz--------------------------------
void beep_sound4k(unsigned int timer){
	while(timer--){
		PIEZO =0;
		__delay_us(120);
		PIEZO =1;
		__delay_us(120);
	}	
}
//Beep sound 2KHz(2048hz)--------------------------------
void beep_sound2k(unsigned int timer){
	while(timer--){
		PIEZO =0;
		__delay_us(240);
		PIEZO =1;
		__delay_us(240);
	}	
}

//Beep sound 1KHz(1024hz)--------------------------------
void beep_sound1k(unsigned int timer){
	while(timer--){
		PIEZO =0;
		__delay_us(486);
		PIEZO =1;
		__delay_us(486);
	}	
}


//Beep click sound --------------------------------
void beep_click(void){
	unsigned char temp=10;
	while(temp--){
		PIEZO =0;
		__delay_us(64);
		PIEZO =1;
		__delay_us(64);
	}	
}

//------------------main
void main(void){
 	unsigned int	temp;
	unsigned char	temp1,temp2,nextflag;

//---------------------------------------------------------
//Initialization
//	OSCCAL = _READ_OSCCAL_DATA();	//OSCCAL AUTO SET
	GIE  = 0;						//Interrupt service is disable
	CMCON  = 7;						//GPIO use all digital port

//	ANSEL  =  	  0b00000000;		//when device is 12F675
				//  76543210
    TRISIO 	=     0b00001000;		//GPIO2 is OUTPUT
    GPIO	=     0b00001000;		//GPIO initialize

//---------------------------------------------------------
//Start up routiene
//buzz test 
//	temp2 = RESULT_BEEP; //Beep
//	while(1){
//		beep_sound1k(1029);
//		beep_sound2k(2083);
//	}

//power on opening Beep
	beep_sound2k(1000);



//Sleep check loop
	while(1){
		nextflag=1;					//sleep escape flag
		do
		{
//setup to sleep routiene
					//  76543210
		    TRISIO 	= 0b00111111;	//GPIO is all input listen mode
			GPPU =  0;				//internal pullup function use
			WPU  =	  0b00110111;	//Pull up port select (ALL Pin Pull Up as low power)
			IOCB =    0b00000100;	//GPIO0 is listen mode
		    GPIO	= 0b00001100;	//GPIO setting (Piezo port is 1)
			__delay_ms(50);			//stabilize time
			GPIO = GPIO;			//Flash port
			GPIF  = 0;				//GPIF flag clear
			GPIE  = 1;				//sleep wake-up function is enable
									//vector non jump and execute next command
			SLEEP();				//sleep!
			NOP();					//Wake up
//--Wake-up start!
		    TRISIO 	= 0b00001000;	//LED out  and PIEZO INIT
		    GPIO	= 0b00001100;	//GPIO initialize
		    TRISIO 	= 0b00001100;	//LED out  and PIEZO input
		    GPIO	= 0b00001100;	//GPIO initialize 
			__delay_ms(10);			//waiting stabilize port time

//Detect of Double cleck
			temp =30000;
			do{
				__delay_us(1);			//wait
				if (PIEZO==0) { 	//twice impact of piezo?
					nextflag=0; 	//yes! twice impact .Pull out loop of sleep.
					break;
				}
			}while(temp--);			//check loop
		}while (nextflag);			//dropout

			
// Wakeup when GPIO0 is high 
	
		GPIE  = 0;	//sleep wake-up function is disable
		GPIF  = 0;	//GPIO int flag reset
		GPPU  = 1;	//internal pullup function disable
	
	    TRISIO 	= 0b00001000;	//GPIO0 is OUTPUT
	    GPIO	= 0b00001000;	//GPIO initialize

//---------------------------------------------------------
//Begin at timer

		beep_sound4k(1000);
//Timer counter
		temp2 = SET_TIMER;		//minute
		while(temp2--){
			temp = 60;			//second count
//1sec timer
			while(temp--){
				LED_RED = 0;	//LED light
				Delay_100ms(2);
				LED_RED = 1;	//LED off
				Delay_100ms(7);
				__delay_ms(100);//adjustment total 1s
				beep_click();	//1 second sound click
			}
		beep_sound4k(10);		//1 minute sound click
		}
//---------------------------------------------------------
//End of timer routiene
//Buzzer OUT (4KHz)
		LED_RED = 0;
		temp2 = RESULT_BEEP; //Beep
		while(temp2--){
			beep_sound1k(1029); //1sec
			beep_sound2k(2083); //1sec
//			Delay_100ms(3);// Beep silent
		}

	Delay_100ms(20);

	}
}
		
